//
// This file was auto-generated, do not edit directly
//

pub mod desktop_shell {
    //! create desktop widgets and helpers
    //!
    //! Traditional user interfaces can rely on this interface to define the
    //! foundations of typical desktops. Currently it's possible to set up
    //! background, panels and locking surfaces.
    use super::Client;
    use super::EventLoopHandle;
    use super::Resource;
    use super::EventResult;

    use super::{Liveness, Implementable};
    use super::interfaces::*;
    use wayland_sys::common::*;
    use std::any::Any;
    use std::ffi::{CString,CStr};
    use std::os::raw::c_void;
    use std::ptr;
    use std::sync::Arc;
    use std::sync::atomic::{AtomicBool, AtomicPtr, Ordering};
    use wayland_sys::RUST_MANAGED;
    use wayland_sys::server::*;
    type UserData = (*mut EventLoopHandle, Option<Box<Any>>,Arc<(AtomicBool, AtomicPtr<()>)>, Option<fn(&DesktopShell)>);

    pub struct DesktopShell {
        ptr: *mut wl_resource,
        data: Option<Arc<(AtomicBool, AtomicPtr<()>)>>
    }

    unsafe impl Send for DesktopShell {}
    unsafe impl Sync for DesktopShell {}
    unsafe impl Resource for DesktopShell {
        fn ptr(&self) -> *mut wl_resource { self.ptr }

        unsafe fn from_ptr_new(ptr: *mut wl_resource) -> DesktopShell {
            let data: *mut UserData = Box::into_raw(Box::new((
                ptr::null_mut(),
                Option::None,
                Arc::new((AtomicBool::new(true), AtomicPtr::new(ptr::null_mut()))),
                Option::None
            )));
            ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_set_user_data, ptr, data as *mut c_void);
            DesktopShell { ptr: ptr, data: Some((&*data).2.clone()) }
        }
        unsafe fn from_ptr_initialized(ptr: *mut wl_resource) -> DesktopShell {

            let rust_managed = ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_instance_of,
                ptr, Self::interface_ptr(), &RUST_MANAGED as *const _ as *const _
            ) != 0;

            if rust_managed {
                let data = ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_get_user_data, ptr) as *mut UserData;
                DesktopShell { ptr: ptr, data: Some((&*data).2.clone()) }
            } else {
                DesktopShell { ptr: ptr, data: Option::None }
            }
        }

        fn interface_ptr() -> *const wl_interface { unsafe { &desktop_shell_interface } }
        fn interface_name() -> &'static str { "desktop_shell"  }
        fn supported_version() -> u32 { 3 }
        fn version(&self) -> i32 { unsafe { ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_get_version, self.ptr()) } }

        fn status(&self) -> Liveness {
            if let Some(ref data) = self.data {
                if data.0.load(Ordering::SeqCst) {
                    Liveness::Alive
                } else {
                    Liveness::Dead
                }
            } else {
                Liveness::Unmanaged
            }
        }

        fn equals(&self, other: &DesktopShell) -> bool {
            self.status() != Liveness::Dead && other.status() != Liveness::Dead && self.ptr == other.ptr
        }

        fn set_user_data(&self, ptr: *mut ()) {
            if let Some(ref data) = self.data {
                data.1.store(ptr, Ordering::SeqCst);
            }
        }
        fn get_user_data(&self) -> *mut () {
            if let Some(ref data) = self.data {
                data.1.load(Ordering::SeqCst)
            } else {
                ::std::ptr::null_mut()
            }
        }

        unsafe fn clone_unchecked(&self) -> DesktopShell {
            DesktopShell {
                ptr: self.ptr,
                data: self.data.clone()
            }
        }
    }
    unsafe impl<ID: 'static> Implementable<ID> for DesktopShell {
        type Implementation = Implementation<ID>;
        #[allow(unused_mut,unused_assignments)]
        unsafe fn __dispatch_msg(&self, client: &Client, opcode: u32, args: *const wl_argument) -> Result<(),()> {

        let data = &mut *(ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_get_user_data, self.ptr()) as *mut UserData);
        let evq = &mut *(data.0);
        let mut kill = false;
        {
            let &mut (ref implementation, ref mut idata) = data.1.as_mut().unwrap().downcast_mut::<(Implementation<ID>, ID)>().unwrap();
            match opcode {
                0 => {
                    let output = {Resource::from_ptr_initialized(*(args.offset(0) as *const *mut wl_resource))};
                    let surface = {Resource::from_ptr_initialized(*(args.offset(1) as *const *mut wl_resource))};
                    (implementation.set_background)(evq, idata, client, self, &output, &surface);
                },
                1 => {
                    let output = {Resource::from_ptr_initialized(*(args.offset(0) as *const *mut wl_resource))};
                    let surface = {Resource::from_ptr_initialized(*(args.offset(1) as *const *mut wl_resource))};
                    (implementation.set_panel)(evq, idata, client, self, &output, &surface);
                },
                2 => {
                    let output = {Resource::from_ptr_initialized(*(args.offset(0) as *const *mut wl_resource))};
                    let surface = {Resource::from_ptr_initialized(*(args.offset(1) as *const *mut wl_resource))};
                    (implementation.set_lock_surface)(evq, idata, client, self, &output, &surface);
                },
                3 => {
                    (implementation.unlock)(evq, idata, client, self);
                },
                4 => {
                    let surface = {Resource::from_ptr_initialized(*(args.offset(0) as *const *mut wl_resource))};
                    (implementation.set_grab_surface)(evq, idata, client, self, &surface);
                },
                5 => {
                    (implementation.desktop_ready)(evq, idata, client, self);
                },
                6 => {
                    let position = {*(args.offset(0) as *const u32)};
                    (implementation.set_panel_position)(evq, idata, client, self, position);
                },
                _ => return Err(())
            }
        }

        if kill {
            let _impl = data.1.take();
            ::std::mem::drop(_impl);
        }
            Ok(())
        }
    }
    #[repr(u32)]
    #[derive(Copy,Clone,Debug,PartialEq)]
    pub enum Cursor {
        None = 0,
        ResizeTop = 1,
        ResizeBottom = 2,
        Arrow = 3,
        ResizeLeft = 4,
        ResizeTopLeft = 5,
        ResizeBottomLeft = 6,
        Move = 7,
        ResizeRight = 8,
        ResizeTopRight = 9,
        ResizeBottomRight = 10,
        Busy = 11,
    }
    impl Cursor {
        pub fn from_raw(n: u32) -> Option<Cursor> {
            match n {
                0 => Some(Cursor::None),
                1 => Some(Cursor::ResizeTop),
                2 => Some(Cursor::ResizeBottom),
                3 => Some(Cursor::Arrow),
                4 => Some(Cursor::ResizeLeft),
                5 => Some(Cursor::ResizeTopLeft),
                6 => Some(Cursor::ResizeBottomLeft),
                7 => Some(Cursor::Move),
                8 => Some(Cursor::ResizeRight),
                9 => Some(Cursor::ResizeTopRight),
                10 => Some(Cursor::ResizeBottomRight),
                11 => Some(Cursor::Busy),
                _ => Option::None
            }
        }
        pub fn to_raw(&self) -> u32 {
            *self as u32
        }
    }
    #[repr(u32)]
    #[derive(Copy,Clone,Debug,PartialEq)]
    pub enum PanelPosition {
        Top = 0,
        Bottom = 1,
        Left = 2,
        Right = 3,
    }
    impl PanelPosition {
        pub fn from_raw(n: u32) -> Option<PanelPosition> {
            match n {
                0 => Some(PanelPosition::Top),
                1 => Some(PanelPosition::Bottom),
                2 => Some(PanelPosition::Left),
                3 => Some(PanelPosition::Right),
                _ => Option::None
            }
        }
        pub fn to_raw(&self) -> u32 {
            *self as u32
        }
    }
    #[repr(u32)]
    #[derive(Copy,Clone,Debug,PartialEq)]
    pub enum Error {
        /// an invalid argument was provided in a request
        InvalidArgument = 0,
    }
    impl Error {
        pub fn from_raw(n: u32) -> Option<Error> {
            match n {
                0 => Some(Error::InvalidArgument),
                _ => Option::None
            }
        }
        pub fn to_raw(&self) -> u32 {
            *self as u32
        }
    }
    pub struct Implementation<ID> {
        ///
        /// **Arguments:** event_queue_handle, interface_data, client, desktop_shell, output, surface
        pub set_background: fn(evqh: &mut EventLoopHandle, data: &mut ID, client: &Client,  desktop_shell: &DesktopShell, output: &super::wl_output::WlOutput, surface: &super::wl_surface::WlSurface),
        ///
        /// **Arguments:** event_queue_handle, interface_data, client, desktop_shell, output, surface
        pub set_panel: fn(evqh: &mut EventLoopHandle, data: &mut ID, client: &Client,  desktop_shell: &DesktopShell, output: &super::wl_output::WlOutput, surface: &super::wl_surface::WlSurface),
        ///
        /// **Arguments:** event_queue_handle, interface_data, client, desktop_shell, output, surface
        pub set_lock_surface: fn(evqh: &mut EventLoopHandle, data: &mut ID, client: &Client,  desktop_shell: &DesktopShell, output: &super::wl_output::WlOutput, surface: &super::wl_surface::WlSurface),
        ///
        /// **Arguments:** event_queue_handle, interface_data, client, desktop_shell
        pub unlock: fn(evqh: &mut EventLoopHandle, data: &mut ID, client: &Client,  desktop_shell: &DesktopShell),
        /// set grab surface
        ///
        /// The surface set by this request will receive a fake
        /// pointer.enter event during grabs at position 0, 0 and is
        /// expected to set an appropriate cursor image as described by
        /// the grab_cursor event sent just before the enter event.
        ///
        /// **Arguments:** event_queue_handle, interface_data, client, desktop_shell, surface
        pub set_grab_surface: fn(evqh: &mut EventLoopHandle, data: &mut ID, client: &Client,  desktop_shell: &DesktopShell, surface: &super::wl_surface::WlSurface),
        /// desktop is ready to be shown
        ///
        /// Tell the server, that enough desktop elements have been drawn
        /// to make the desktop look ready for use. During start-up, the
        /// server can wait for this request with a black screen before
        /// starting to fade in the desktop, for instance. If the client
        /// parts of a desktop take a long time to initialize, we avoid
        /// showing temporary garbage.
        ///
        /// **Arguments:** event_queue_handle, interface_data, client, desktop_shell
        ///
        /// This event only exists since version 2 of the interface
        pub desktop_ready: fn(evqh: &mut EventLoopHandle, data: &mut ID, client: &Client,  desktop_shell: &DesktopShell),
        /// set panel position
        ///
        /// Tell the shell which side of the screen the panel is
        /// located. This is so that new windows do not overlap the panel
        /// and maximized windows maximize properly.
        ///
        /// **Arguments:** event_queue_handle, interface_data, client, desktop_shell, position
        ///
        /// This event only exists since version 3 of the interface
        pub set_panel_position: fn(evqh: &mut EventLoopHandle, data: &mut ID, client: &Client,  desktop_shell: &DesktopShell, position: u32),
    }

    impl<ID> Copy for Implementation<ID> {}
    impl<ID> Clone for Implementation<ID> {
        fn clone(&self) -> Implementation<ID> {
            *self
        }
    }

    impl<ID> PartialEq for Implementation<ID> {
        fn eq(&self, other: &Implementation<ID>) -> bool {
            true
            && (self.set_background as usize == other.set_background as usize)
            && (self.set_panel as usize == other.set_panel as usize)
            && (self.set_lock_surface as usize == other.set_lock_surface as usize)
            && (self.unlock as usize == other.unlock as usize)
            && (self.set_grab_surface as usize == other.set_grab_surface as usize)
            && (self.desktop_ready as usize == other.desktop_ready as usize)
            && (self.set_panel_position as usize == other.set_panel_position as usize)

        }
    }

    const DESKTOP_SHELL_CONFIGURE: u32 = 0;
    const DESKTOP_SHELL_PREPARE_LOCK_SURFACE: u32 = 1;
    const DESKTOP_SHELL_GRAB_CURSOR: u32 = 2;
    impl DesktopShell {
        pub fn configure(&self, edges: u32, surface: &super::wl_surface::WlSurface, width: i32, height: i32) ->EventResult<()> {
            if self.status() == Liveness::Dead { return EventResult::Destroyed }
            unsafe { ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_post_event, self.ptr(), DESKTOP_SHELL_CONFIGURE, edges, surface.ptr(), width, height) };
            EventResult::Sent(())
        }
        /// tell the client to create, set the lock surface
        ///
        /// Tell the client we want it to create and set the lock surface, which is
        /// a GUI asking the user to unlock the screen. The lock surface is
        /// announced with 'set_lock_surface'. Whether or not the client actually
        /// implements locking, it MUST send 'unlock' request to let the normal
        /// desktop resume.
        pub fn prepare_lock_surface(&self) ->EventResult<()> {
            if self.status() == Liveness::Dead { return EventResult::Destroyed }
            unsafe { ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_post_event, self.ptr(), DESKTOP_SHELL_PREPARE_LOCK_SURFACE) };
            EventResult::Sent(())
        }
        /// tell client what cursor to show during a grab
        ///
        /// This event will be sent immediately before a fake enter event on the
        /// grab surface.
        pub fn grab_cursor(&self, cursor: u32) ->EventResult<()> {
            if self.status() == Liveness::Dead { return EventResult::Destroyed }
            unsafe { ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_post_event, self.ptr(), DESKTOP_SHELL_GRAB_CURSOR, cursor) };
            EventResult::Sent(())
        }
    }
}
pub mod screensaver {
    //! interface for implementing screensavers
    //!
    //! Only one client can bind this interface at a time.
    use super::Client;
    use super::EventLoopHandle;
    use super::Resource;
    use super::EventResult;

    use super::{Liveness, Implementable};
    use super::interfaces::*;
    use wayland_sys::common::*;
    use std::any::Any;
    use std::ffi::{CString,CStr};
    use std::os::raw::c_void;
    use std::ptr;
    use std::sync::Arc;
    use std::sync::atomic::{AtomicBool, AtomicPtr, Ordering};
    use wayland_sys::RUST_MANAGED;
    use wayland_sys::server::*;
    type UserData = (*mut EventLoopHandle, Option<Box<Any>>,Arc<(AtomicBool, AtomicPtr<()>)>, Option<fn(&Screensaver)>);

    pub struct Screensaver {
        ptr: *mut wl_resource,
        data: Option<Arc<(AtomicBool, AtomicPtr<()>)>>
    }

    unsafe impl Send for Screensaver {}
    unsafe impl Sync for Screensaver {}
    unsafe impl Resource for Screensaver {
        fn ptr(&self) -> *mut wl_resource { self.ptr }

        unsafe fn from_ptr_new(ptr: *mut wl_resource) -> Screensaver {
            let data: *mut UserData = Box::into_raw(Box::new((
                ptr::null_mut(),
                Option::None,
                Arc::new((AtomicBool::new(true), AtomicPtr::new(ptr::null_mut()))),
                Option::None
            )));
            ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_set_user_data, ptr, data as *mut c_void);
            Screensaver { ptr: ptr, data: Some((&*data).2.clone()) }
        }
        unsafe fn from_ptr_initialized(ptr: *mut wl_resource) -> Screensaver {

            let rust_managed = ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_instance_of,
                ptr, Self::interface_ptr(), &RUST_MANAGED as *const _ as *const _
            ) != 0;

            if rust_managed {
                let data = ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_get_user_data, ptr) as *mut UserData;
                Screensaver { ptr: ptr, data: Some((&*data).2.clone()) }
            } else {
                Screensaver { ptr: ptr, data: Option::None }
            }
        }

        fn interface_ptr() -> *const wl_interface { unsafe { &screensaver_interface } }
        fn interface_name() -> &'static str { "screensaver"  }
        fn supported_version() -> u32 { 1 }
        fn version(&self) -> i32 { unsafe { ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_get_version, self.ptr()) } }

        fn status(&self) -> Liveness {
            if let Some(ref data) = self.data {
                if data.0.load(Ordering::SeqCst) {
                    Liveness::Alive
                } else {
                    Liveness::Dead
                }
            } else {
                Liveness::Unmanaged
            }
        }

        fn equals(&self, other: &Screensaver) -> bool {
            self.status() != Liveness::Dead && other.status() != Liveness::Dead && self.ptr == other.ptr
        }

        fn set_user_data(&self, ptr: *mut ()) {
            if let Some(ref data) = self.data {
                data.1.store(ptr, Ordering::SeqCst);
            }
        }
        fn get_user_data(&self) -> *mut () {
            if let Some(ref data) = self.data {
                data.1.load(Ordering::SeqCst)
            } else {
                ::std::ptr::null_mut()
            }
        }

        unsafe fn clone_unchecked(&self) -> Screensaver {
            Screensaver {
                ptr: self.ptr,
                data: self.data.clone()
            }
        }
    }
    unsafe impl<ID: 'static> Implementable<ID> for Screensaver {
        type Implementation = Implementation<ID>;
        #[allow(unused_mut,unused_assignments)]
        unsafe fn __dispatch_msg(&self, client: &Client, opcode: u32, args: *const wl_argument) -> Result<(),()> {

        let data = &mut *(ffi_dispatch!(WAYLAND_SERVER_HANDLE, wl_resource_get_user_data, self.ptr()) as *mut UserData);
        let evq = &mut *(data.0);
        let mut kill = false;
        {
            let &mut (ref implementation, ref mut idata) = data.1.as_mut().unwrap().downcast_mut::<(Implementation<ID>, ID)>().unwrap();
            match opcode {
                0 => {
                    let surface = {Resource::from_ptr_initialized(*(args.offset(0) as *const *mut wl_resource))};
                    let output = {Resource::from_ptr_initialized(*(args.offset(1) as *const *mut wl_resource))};
                    (implementation.set_surface)(evq, idata, client, self, &surface, &output);
                },
                _ => return Err(())
            }
        }

        if kill {
            let _impl = data.1.take();
            ::std::mem::drop(_impl);
        }
            Ok(())
        }
    }
    pub struct Implementation<ID> {
        /// set the surface type as a screensaver
        ///
        /// A screensaver surface is normally hidden, and only visible after an
        /// idle timeout.
        ///
        /// **Arguments:** event_queue_handle, interface_data, client, screensaver, surface, output
        pub set_surface: fn(evqh: &mut EventLoopHandle, data: &mut ID, client: &Client,  screensaver: &Screensaver, surface: &super::wl_surface::WlSurface, output: &super::wl_output::WlOutput),
    }

    impl<ID> Copy for Implementation<ID> {}
    impl<ID> Clone for Implementation<ID> {
        fn clone(&self) -> Implementation<ID> {
            *self
        }
    }

    impl<ID> PartialEq for Implementation<ID> {
        fn eq(&self, other: &Implementation<ID>) -> bool {
            true
            && (self.set_surface as usize == other.set_surface as usize)

        }
    }

    impl Screensaver {
    }
}
